#include "AST.h"
#include "NameContext.h"
#include "NamesQueue.h"


NamesQueue unresolvedNames;


void NamesQueue::resolve()
{
  NamesQueue postponedUnits;
  
  while (!empty())
    {
      CompileUnitNode &unit = *front();
      pop_front();
      
      bool postponed = false;
      TreeNode::NameContext context( postponed );
      unit.resolveName( context );
      
      if (postponed)
	postponedUnits.push_back( &unit );
    }
  
  splice( end(), postponedUnits );
}


// Local Variables:
// c-file-style: "gnu"
// End:
