#ifndef INCLUDE_CLONE_H
#define INCLUDE_CLONE_H


template< class Node > Node *CloneTree(Node *t, bool cleanUseDef = false)
{
  Node *newNode = t->clone();
  if (cleanUseDef) {
    newNode->setUses(NULL);
    newNode->setDefs(NULL);
  }
  const int childCount = newNode->arity();
  for (int sweep = 0; sweep < childCount; ++sweep)
    newNode->child(sweep, CloneTree(newNode->child(sweep), cleanUseDef));

  return newNode;
}


#endif // !INCLUDE_CLONE_H
