# -----------------------------------------------------------------------------
#
# Name: d*.tst
#
# Version: 1.0
#
# Creator: miyamoto
#
# Date: 980205
#
# Purpose:
#   Sanity test for domains.  It will create the necessary files for an
#   upper level tester to create an executable, run it, and compare the
#   output to an expected output.
#
# Change Log:
#
# -----------------------------------------------------------------------------

cat > test.ti << '@eof'
// Rect Domain

// Uses fake templates.  Replace V_ARITY with arity you want.

// import ti.domains.*;

class Foobar {
  int x;

  Foobar() { x = 1; }
  Foobar(int y) { x = y; }

  public static void main(String[] args) {

    RectDomain<1> rdx1;
    RectDomain<3> rd, rd2, rd3;
    Domain<3> x;
    Point<3> p;
    Point<3> p2;
    Foobar foobar;

    p = [7,7,7];
    p2 = p + [7,7,7];
    rdx1 = [7 : 9];
    rd2 = [p : [ 9,9,9 ] : [ 1,1,1 ]];
    rd3 = [[ 10,1,1 ] : [ 19,9,9 ] : [ 1,1,1 ]];
    x = rd2 + rd3;
    rd = rd3.accrete(5);
    foobar = new Foobar();
    new Foobar(7);
    p = Point<3>.direction(1, 1);
    foreach (p within x) {
      Point<3> q;
      System.out.print("p = [");
      System.out.print(p[1]);
      System.out.print(",");
      System.out.print(p[2]);
      System.out.print(",");
      System.out.print(p[3]);
      System.out.println("]");
      q = p;
    }
  }
}
@eof

cat > stdout.old << '@eof'
p = [7,7,7]
p = [7,7,8]
p = [7,7,9]
p = [7,8,7]
p = [7,8,8]
p = [7,8,9]
p = [7,9,7]
p = [7,9,8]
p = [7,9,9]
p = [8,7,7]
p = [8,7,8]
p = [8,7,9]
p = [8,8,7]
p = [8,8,8]
p = [8,8,9]
p = [8,9,7]
p = [8,9,8]
p = [8,9,9]
p = [9,7,7]
p = [9,7,8]
p = [9,7,9]
p = [9,8,7]
p = [9,8,8]
p = [9,8,9]
p = [9,9,7]
p = [9,9,8]
p = [9,9,9]
p = [10,1,1]
p = [10,1,2]
p = [10,1,3]
p = [10,1,4]
p = [10,1,5]
p = [10,1,6]
p = [10,1,7]
p = [10,1,8]
p = [10,1,9]
p = [10,2,1]
p = [10,2,2]
p = [10,2,3]
p = [10,2,4]
p = [10,2,5]
p = [10,2,6]
p = [10,2,7]
p = [10,2,8]
p = [10,2,9]
p = [10,3,1]
p = [10,3,2]
p = [10,3,3]
p = [10,3,4]
p = [10,3,5]
p = [10,3,6]
p = [10,3,7]
p = [10,3,8]
p = [10,3,9]
p = [10,4,1]
p = [10,4,2]
p = [10,4,3]
p = [10,4,4]
p = [10,4,5]
p = [10,4,6]
p = [10,4,7]
p = [10,4,8]
p = [10,4,9]
p = [10,5,1]
p = [10,5,2]
p = [10,5,3]
p = [10,5,4]
p = [10,5,5]
p = [10,5,6]
p = [10,5,7]
p = [10,5,8]
p = [10,5,9]
p = [10,6,1]
p = [10,6,2]
p = [10,6,3]
p = [10,6,4]
p = [10,6,5]
p = [10,6,6]
p = [10,6,7]
p = [10,6,8]
p = [10,6,9]
p = [10,7,1]
p = [10,7,2]
p = [10,7,3]
p = [10,7,4]
p = [10,7,5]
p = [10,7,6]
p = [10,7,7]
p = [10,7,8]
p = [10,7,9]
p = [10,8,1]
p = [10,8,2]
p = [10,8,3]
p = [10,8,4]
p = [10,8,5]
p = [10,8,6]
p = [10,8,7]
p = [10,8,8]
p = [10,8,9]
p = [10,9,1]
p = [10,9,2]
p = [10,9,3]
p = [10,9,4]
p = [10,9,5]
p = [10,9,6]
p = [10,9,7]
p = [10,9,8]
p = [10,9,9]
p = [11,1,1]
p = [11,1,2]
p = [11,1,3]
p = [11,1,4]
p = [11,1,5]
p = [11,1,6]
p = [11,1,7]
p = [11,1,8]
p = [11,1,9]
p = [11,2,1]
p = [11,2,2]
p = [11,2,3]
p = [11,2,4]
p = [11,2,5]
p = [11,2,6]
p = [11,2,7]
p = [11,2,8]
p = [11,2,9]
p = [11,3,1]
p = [11,3,2]
p = [11,3,3]
p = [11,3,4]
p = [11,3,5]
p = [11,3,6]
p = [11,3,7]
p = [11,3,8]
p = [11,3,9]
p = [11,4,1]
p = [11,4,2]
p = [11,4,3]
p = [11,4,4]
p = [11,4,5]
p = [11,4,6]
p = [11,4,7]
p = [11,4,8]
p = [11,4,9]
p = [11,5,1]
p = [11,5,2]
p = [11,5,3]
p = [11,5,4]
p = [11,5,5]
p = [11,5,6]
p = [11,5,7]
p = [11,5,8]
p = [11,5,9]
p = [11,6,1]
p = [11,6,2]
p = [11,6,3]
p = [11,6,4]
p = [11,6,5]
p = [11,6,6]
p = [11,6,7]
p = [11,6,8]
p = [11,6,9]
p = [11,7,1]
p = [11,7,2]
p = [11,7,3]
p = [11,7,4]
p = [11,7,5]
p = [11,7,6]
p = [11,7,7]
p = [11,7,8]
p = [11,7,9]
p = [11,8,1]
p = [11,8,2]
p = [11,8,3]
p = [11,8,4]
p = [11,8,5]
p = [11,8,6]
p = [11,8,7]
p = [11,8,8]
p = [11,8,9]
p = [11,9,1]
p = [11,9,2]
p = [11,9,3]
p = [11,9,4]
p = [11,9,5]
p = [11,9,6]
p = [11,9,7]
p = [11,9,8]
p = [11,9,9]
p = [12,1,1]
p = [12,1,2]
p = [12,1,3]
p = [12,1,4]
p = [12,1,5]
p = [12,1,6]
p = [12,1,7]
p = [12,1,8]
p = [12,1,9]
p = [12,2,1]
p = [12,2,2]
p = [12,2,3]
p = [12,2,4]
p = [12,2,5]
p = [12,2,6]
p = [12,2,7]
p = [12,2,8]
p = [12,2,9]
p = [12,3,1]
p = [12,3,2]
p = [12,3,3]
p = [12,3,4]
p = [12,3,5]
p = [12,3,6]
p = [12,3,7]
p = [12,3,8]
p = [12,3,9]
p = [12,4,1]
p = [12,4,2]
p = [12,4,3]
p = [12,4,4]
p = [12,4,5]
p = [12,4,6]
p = [12,4,7]
p = [12,4,8]
p = [12,4,9]
p = [12,5,1]
p = [12,5,2]
p = [12,5,3]
p = [12,5,4]
p = [12,5,5]
p = [12,5,6]
p = [12,5,7]
p = [12,5,8]
p = [12,5,9]
p = [12,6,1]
p = [12,6,2]
p = [12,6,3]
p = [12,6,4]
p = [12,6,5]
p = [12,6,6]
p = [12,6,7]
p = [12,6,8]
p = [12,6,9]
p = [12,7,1]
p = [12,7,2]
p = [12,7,3]
p = [12,7,4]
p = [12,7,5]
p = [12,7,6]
p = [12,7,7]
p = [12,7,8]
p = [12,7,9]
p = [12,8,1]
p = [12,8,2]
p = [12,8,3]
p = [12,8,4]
p = [12,8,5]
p = [12,8,6]
p = [12,8,7]
p = [12,8,8]
p = [12,8,9]
p = [12,9,1]
p = [12,9,2]
p = [12,9,3]
p = [12,9,4]
p = [12,9,5]
p = [12,9,6]
p = [12,9,7]
p = [12,9,8]
p = [12,9,9]
p = [13,1,1]
p = [13,1,2]
p = [13,1,3]
p = [13,1,4]
p = [13,1,5]
p = [13,1,6]
p = [13,1,7]
p = [13,1,8]
p = [13,1,9]
p = [13,2,1]
p = [13,2,2]
p = [13,2,3]
p = [13,2,4]
p = [13,2,5]
p = [13,2,6]
p = [13,2,7]
p = [13,2,8]
p = [13,2,9]
p = [13,3,1]
p = [13,3,2]
p = [13,3,3]
p = [13,3,4]
p = [13,3,5]
p = [13,3,6]
p = [13,3,7]
p = [13,3,8]
p = [13,3,9]
p = [13,4,1]
p = [13,4,2]
p = [13,4,3]
p = [13,4,4]
p = [13,4,5]
p = [13,4,6]
p = [13,4,7]
p = [13,4,8]
p = [13,4,9]
p = [13,5,1]
p = [13,5,2]
p = [13,5,3]
p = [13,5,4]
p = [13,5,5]
p = [13,5,6]
p = [13,5,7]
p = [13,5,8]
p = [13,5,9]
p = [13,6,1]
p = [13,6,2]
p = [13,6,3]
p = [13,6,4]
p = [13,6,5]
p = [13,6,6]
p = [13,6,7]
p = [13,6,8]
p = [13,6,9]
p = [13,7,1]
p = [13,7,2]
p = [13,7,3]
p = [13,7,4]
p = [13,7,5]
p = [13,7,6]
p = [13,7,7]
p = [13,7,8]
p = [13,7,9]
p = [13,8,1]
p = [13,8,2]
p = [13,8,3]
p = [13,8,4]
p = [13,8,5]
p = [13,8,6]
p = [13,8,7]
p = [13,8,8]
p = [13,8,9]
p = [13,9,1]
p = [13,9,2]
p = [13,9,3]
p = [13,9,4]
p = [13,9,5]
p = [13,9,6]
p = [13,9,7]
p = [13,9,8]
p = [13,9,9]
p = [14,1,1]
p = [14,1,2]
p = [14,1,3]
p = [14,1,4]
p = [14,1,5]
p = [14,1,6]
p = [14,1,7]
p = [14,1,8]
p = [14,1,9]
p = [14,2,1]
p = [14,2,2]
p = [14,2,3]
p = [14,2,4]
p = [14,2,5]
p = [14,2,6]
p = [14,2,7]
p = [14,2,8]
p = [14,2,9]
p = [14,3,1]
p = [14,3,2]
p = [14,3,3]
p = [14,3,4]
p = [14,3,5]
p = [14,3,6]
p = [14,3,7]
p = [14,3,8]
p = [14,3,9]
p = [14,4,1]
p = [14,4,2]
p = [14,4,3]
p = [14,4,4]
p = [14,4,5]
p = [14,4,6]
p = [14,4,7]
p = [14,4,8]
p = [14,4,9]
p = [14,5,1]
p = [14,5,2]
p = [14,5,3]
p = [14,5,4]
p = [14,5,5]
p = [14,5,6]
p = [14,5,7]
p = [14,5,8]
p = [14,5,9]
p = [14,6,1]
p = [14,6,2]
p = [14,6,3]
p = [14,6,4]
p = [14,6,5]
p = [14,6,6]
p = [14,6,7]
p = [14,6,8]
p = [14,6,9]
p = [14,7,1]
p = [14,7,2]
p = [14,7,3]
p = [14,7,4]
p = [14,7,5]
p = [14,7,6]
p = [14,7,7]
p = [14,7,8]
p = [14,7,9]
p = [14,8,1]
p = [14,8,2]
p = [14,8,3]
p = [14,8,4]
p = [14,8,5]
p = [14,8,6]
p = [14,8,7]
p = [14,8,8]
p = [14,8,9]
p = [14,9,1]
p = [14,9,2]
p = [14,9,3]
p = [14,9,4]
p = [14,9,5]
p = [14,9,6]
p = [14,9,7]
p = [14,9,8]
p = [14,9,9]
p = [15,1,1]
p = [15,1,2]
p = [15,1,3]
p = [15,1,4]
p = [15,1,5]
p = [15,1,6]
p = [15,1,7]
p = [15,1,8]
p = [15,1,9]
p = [15,2,1]
p = [15,2,2]
p = [15,2,3]
p = [15,2,4]
p = [15,2,5]
p = [15,2,6]
p = [15,2,7]
p = [15,2,8]
p = [15,2,9]
p = [15,3,1]
p = [15,3,2]
p = [15,3,3]
p = [15,3,4]
p = [15,3,5]
p = [15,3,6]
p = [15,3,7]
p = [15,3,8]
p = [15,3,9]
p = [15,4,1]
p = [15,4,2]
p = [15,4,3]
p = [15,4,4]
p = [15,4,5]
p = [15,4,6]
p = [15,4,7]
p = [15,4,8]
p = [15,4,9]
p = [15,5,1]
p = [15,5,2]
p = [15,5,3]
p = [15,5,4]
p = [15,5,5]
p = [15,5,6]
p = [15,5,7]
p = [15,5,8]
p = [15,5,9]
p = [15,6,1]
p = [15,6,2]
p = [15,6,3]
p = [15,6,4]
p = [15,6,5]
p = [15,6,6]
p = [15,6,7]
p = [15,6,8]
p = [15,6,9]
p = [15,7,1]
p = [15,7,2]
p = [15,7,3]
p = [15,7,4]
p = [15,7,5]
p = [15,7,6]
p = [15,7,7]
p = [15,7,8]
p = [15,7,9]
p = [15,8,1]
p = [15,8,2]
p = [15,8,3]
p = [15,8,4]
p = [15,8,5]
p = [15,8,6]
p = [15,8,7]
p = [15,8,8]
p = [15,8,9]
p = [15,9,1]
p = [15,9,2]
p = [15,9,3]
p = [15,9,4]
p = [15,9,5]
p = [15,9,6]
p = [15,9,7]
p = [15,9,8]
p = [15,9,9]
p = [16,1,1]
p = [16,1,2]
p = [16,1,3]
p = [16,1,4]
p = [16,1,5]
p = [16,1,6]
p = [16,1,7]
p = [16,1,8]
p = [16,1,9]
p = [16,2,1]
p = [16,2,2]
p = [16,2,3]
p = [16,2,4]
p = [16,2,5]
p = [16,2,6]
p = [16,2,7]
p = [16,2,8]
p = [16,2,9]
p = [16,3,1]
p = [16,3,2]
p = [16,3,3]
p = [16,3,4]
p = [16,3,5]
p = [16,3,6]
p = [16,3,7]
p = [16,3,8]
p = [16,3,9]
p = [16,4,1]
p = [16,4,2]
p = [16,4,3]
p = [16,4,4]
p = [16,4,5]
p = [16,4,6]
p = [16,4,7]
p = [16,4,8]
p = [16,4,9]
p = [16,5,1]
p = [16,5,2]
p = [16,5,3]
p = [16,5,4]
p = [16,5,5]
p = [16,5,6]
p = [16,5,7]
p = [16,5,8]
p = [16,5,9]
p = [16,6,1]
p = [16,6,2]
p = [16,6,3]
p = [16,6,4]
p = [16,6,5]
p = [16,6,6]
p = [16,6,7]
p = [16,6,8]
p = [16,6,9]
p = [16,7,1]
p = [16,7,2]
p = [16,7,3]
p = [16,7,4]
p = [16,7,5]
p = [16,7,6]
p = [16,7,7]
p = [16,7,8]
p = [16,7,9]
p = [16,8,1]
p = [16,8,2]
p = [16,8,3]
p = [16,8,4]
p = [16,8,5]
p = [16,8,6]
p = [16,8,7]
p = [16,8,8]
p = [16,8,9]
p = [16,9,1]
p = [16,9,2]
p = [16,9,3]
p = [16,9,4]
p = [16,9,5]
p = [16,9,6]
p = [16,9,7]
p = [16,9,8]
p = [16,9,9]
p = [17,1,1]
p = [17,1,2]
p = [17,1,3]
p = [17,1,4]
p = [17,1,5]
p = [17,1,6]
p = [17,1,7]
p = [17,1,8]
p = [17,1,9]
p = [17,2,1]
p = [17,2,2]
p = [17,2,3]
p = [17,2,4]
p = [17,2,5]
p = [17,2,6]
p = [17,2,7]
p = [17,2,8]
p = [17,2,9]
p = [17,3,1]
p = [17,3,2]
p = [17,3,3]
p = [17,3,4]
p = [17,3,5]
p = [17,3,6]
p = [17,3,7]
p = [17,3,8]
p = [17,3,9]
p = [17,4,1]
p = [17,4,2]
p = [17,4,3]
p = [17,4,4]
p = [17,4,5]
p = [17,4,6]
p = [17,4,7]
p = [17,4,8]
p = [17,4,9]
p = [17,5,1]
p = [17,5,2]
p = [17,5,3]
p = [17,5,4]
p = [17,5,5]
p = [17,5,6]
p = [17,5,7]
p = [17,5,8]
p = [17,5,9]
p = [17,6,1]
p = [17,6,2]
p = [17,6,3]
p = [17,6,4]
p = [17,6,5]
p = [17,6,6]
p = [17,6,7]
p = [17,6,8]
p = [17,6,9]
p = [17,7,1]
p = [17,7,2]
p = [17,7,3]
p = [17,7,4]
p = [17,7,5]
p = [17,7,6]
p = [17,7,7]
p = [17,7,8]
p = [17,7,9]
p = [17,8,1]
p = [17,8,2]
p = [17,8,3]
p = [17,8,4]
p = [17,8,5]
p = [17,8,6]
p = [17,8,7]
p = [17,8,8]
p = [17,8,9]
p = [17,9,1]
p = [17,9,2]
p = [17,9,3]
p = [17,9,4]
p = [17,9,5]
p = [17,9,6]
p = [17,9,7]
p = [17,9,8]
p = [17,9,9]
p = [18,1,1]
p = [18,1,2]
p = [18,1,3]
p = [18,1,4]
p = [18,1,5]
p = [18,1,6]
p = [18,1,7]
p = [18,1,8]
p = [18,1,9]
p = [18,2,1]
p = [18,2,2]
p = [18,2,3]
p = [18,2,4]
p = [18,2,5]
p = [18,2,6]
p = [18,2,7]
p = [18,2,8]
p = [18,2,9]
p = [18,3,1]
p = [18,3,2]
p = [18,3,3]
p = [18,3,4]
p = [18,3,5]
p = [18,3,6]
p = [18,3,7]
p = [18,3,8]
p = [18,3,9]
p = [18,4,1]
p = [18,4,2]
p = [18,4,3]
p = [18,4,4]
p = [18,4,5]
p = [18,4,6]
p = [18,4,7]
p = [18,4,8]
p = [18,4,9]
p = [18,5,1]
p = [18,5,2]
p = [18,5,3]
p = [18,5,4]
p = [18,5,5]
p = [18,5,6]
p = [18,5,7]
p = [18,5,8]
p = [18,5,9]
p = [18,6,1]
p = [18,6,2]
p = [18,6,3]
p = [18,6,4]
p = [18,6,5]
p = [18,6,6]
p = [18,6,7]
p = [18,6,8]
p = [18,6,9]
p = [18,7,1]
p = [18,7,2]
p = [18,7,3]
p = [18,7,4]
p = [18,7,5]
p = [18,7,6]
p = [18,7,7]
p = [18,7,8]
p = [18,7,9]
p = [18,8,1]
p = [18,8,2]
p = [18,8,3]
p = [18,8,4]
p = [18,8,5]
p = [18,8,6]
p = [18,8,7]
p = [18,8,8]
p = [18,8,9]
p = [18,9,1]
p = [18,9,2]
p = [18,9,3]
p = [18,9,4]
p = [18,9,5]
p = [18,9,6]
p = [18,9,7]
p = [18,9,8]
p = [18,9,9]
p = [19,1,1]
p = [19,1,2]
p = [19,1,3]
p = [19,1,4]
p = [19,1,5]
p = [19,1,6]
p = [19,1,7]
p = [19,1,8]
p = [19,1,9]
p = [19,2,1]
p = [19,2,2]
p = [19,2,3]
p = [19,2,4]
p = [19,2,5]
p = [19,2,6]
p = [19,2,7]
p = [19,2,8]
p = [19,2,9]
p = [19,3,1]
p = [19,3,2]
p = [19,3,3]
p = [19,3,4]
p = [19,3,5]
p = [19,3,6]
p = [19,3,7]
p = [19,3,8]
p = [19,3,9]
p = [19,4,1]
p = [19,4,2]
p = [19,4,3]
p = [19,4,4]
p = [19,4,5]
p = [19,4,6]
p = [19,4,7]
p = [19,4,8]
p = [19,4,9]
p = [19,5,1]
p = [19,5,2]
p = [19,5,3]
p = [19,5,4]
p = [19,5,5]
p = [19,5,6]
p = [19,5,7]
p = [19,5,8]
p = [19,5,9]
p = [19,6,1]
p = [19,6,2]
p = [19,6,3]
p = [19,6,4]
p = [19,6,5]
p = [19,6,6]
p = [19,6,7]
p = [19,6,8]
p = [19,6,9]
p = [19,7,1]
p = [19,7,2]
p = [19,7,3]
p = [19,7,4]
p = [19,7,5]
p = [19,7,6]
p = [19,7,7]
p = [19,7,8]
p = [19,7,9]
p = [19,8,1]
p = [19,8,2]
p = [19,8,3]
p = [19,8,4]
p = [19,8,5]
p = [19,8,6]
p = [19,8,7]
p = [19,8,8]
p = [19,8,9]
p = [19,9,1]
p = [19,9,2]
p = [19,9,3]
p = [19,9,4]
p = [19,9,5]
p = [19,9,6]
p = [19,9,7]
p = [19,9,8]
p = [19,9,9]
@eof

cat > stderr.old << '@eof'
@eof
