#include <AST.h>
#include <SolverInferContext.h>
#include <solver.h>


void MethodCallNode::inferSharingLate( const SharingContext &context )
{
  TreeNode::inferSharingLate( context );

  const TypeNode &dispatcher = *method()->accessedObjectType();
  if (dispatcher.isTitaniumArrayType())
    {
      const string * const name = decl()->name();
      static const string * const copy = intern( "copy" );
      if (name == copy)
	{
	  const TypeNode &donor = *args()->child( 0 )->type();
	  if (!donor.isLocal())
	    context.solver.mustBeShared( donor );
	}
    }
}


void SuperConstructorCallNode::inferSharingLate( const SharingContext &context )
{
  TreeNode::inferSharingLate( context );
  context.solver.subsumedBy( *context.method, *decl()->type() );
}


void ThisConstructorCallNode::inferSharingLate( const SharingContext &context )
{
  TreeNode::inferSharingLate( context );
  context.solver.subsumedBy( *context.method, *decl()->type() );
}
