#include "native-utils.h"

#ifndef UNINITIALIZED_CHECKING
#if BOUNDS_CHECKING
#define UNINITIALIZED_CHECKING 1
#endif
#endif

#if UNINITIALIZED_CHECKING
/* "&" operator below fixes a gcc 2.96 inliner problem */
#define assertExists(x, where)					\
  if (PREDICT_FALSE((&(x))->stride[0] == 0)) {					\
    fprintf(stderr, "fatal error: "				\
	    "attempt to use uninitialized array at %s\n",	\
	    where);						\
    assert(0);							\
    exit(-1);							\
  }
#else
#define assertExists(x, where)
#endif
