/*									tab:4
 *
 * com.header - Header file to generate com.sc
 *
 * 
 * "Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Arvind Krishnamurthy
 * Version:			6
 * Creation Date:	Apr  2 13:42:47 1993
 * Filename:		com.sc
 * History:              
 *	ssl	6	Thu Oct 28 23:41:04 1993
 *		com.h and cm/cmmd.h are now included with split-c.h
 *	LTL	4	Mon Aug 16 15:33:59 1993
 *		Fixed it up for version 112 to support CMMD
 *	AK	2	Fri Apr  2 13:42:47 1993
 *		Obtained from David's initial version of com library.
 */

#include <tic.h>

/*
  This library provides global communication support for Split-C, including
  broadcasts, reductions, and scans.  

  It provides operations in which all processors participate.
  There are two basic styles: a processor-oriented functional interface
  and a spread array interface.

  Currently only the processor interface is supported.

  Eventually it will also provide autonomous operations.

  An all_ routine end with a barrier, so that there is no conflict on
  use of internal state. 

*/

#define ADD(A, B)	(A + B)
#ifdef MAX
#undef MAX
#endif
#define MAX(A, B)	(A < B ? B : A)
#ifdef MIN
#undef MIN
#endif
#define MIN(A, B)	(A < B ? A : B)
#define MULT(A, B)	(A * B)
#define OR(A, B)	(A | B)
#define XOR(A, B)	(A ^ B)
#define AND(A, B)	(A & B)

#include "com.def"





