/*									tab:4
 *
 * barrier.h - 
 *
 * "Copyright (c) 1996 and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Andrea C. Dusseau
 * Version:			2
 * Creation Date:	Mon Feb 12 23:43:27 1996
 * Filename:		barrier.h
 * History:
 */


#ifndef __BARRIER_H__
#define __BARRIER_H__

extern void __barrier_incr_handler(void *token, int *val);
extern __tic_lock_t Barrier_mutex;

extern void barrier_init(void);
extern void barrier_up(void);
extern void barrier_down(void);

EXTERN INLINE_MODIFIER void barrier(void)
#ifdef COMM_AM2
INLINE({
	barrier_up();
	barrier_down();
})
#else /* smp only needs one */
INLINE({
	barrier_up();
})
#endif

/* A barrier of just the threads on this box (used for initialization) */
void local_barrier();

#endif

