object_dir := $(cache_dir)

-include $(depends_mk)

$(cache_dir)/%.o : $(generate_dir)/%.c $(cache_dir)/%.cmd
	$(message) Compiling $* ... $(pipe_demangler)
	$(cc_command) -o $@ -c $<

$(cache_dir)/%.s : $(generate_dir)/%.c $(cache_dir)/%.cmd
	$(message) Compiling $* to assembly... $(pipe_demangler)
	$(cc_command) -o $@ -S $<

$(generate_dir)/%.o : $(cache_dir)/%.o
	cp -p $< $@

$(generate_dir)/%.s : $(cache_dir)/%.s
	cp -p $< $@

$(stamp_cache) : $(refresh_cache) $(stamp_tc)
	$(message) Checking and updating cache ...
	[ -d $(cache_dir) ] || mkdir -p $(cache_dir)
	$(refresh_cache) $(generate_dir) $(cache_dir) '$(clean_tc_command)' '$(clean_cc_command)'
	touch $@
