// WARNING: This file is automatically generated.
// Uses faked templates.  Replace 2 with specified.

package ti.domains;

//
// ========================
// Multi Rect Domain Type A
// ========================
//
// This represents a domain that is a list of Rect Domains.  It
// is optimized for a fast "foreach" at the expense of set comparisons
// and operations.
//

public class tiMultiRectADomain2 extends tiDomain2 {

  // Constructors
  public tiMultiRectADomain2() {
    rects = new (tiDomains.region) tiRectDomainList2();
  }
  public tiMultiRectADomain2(tiRectDomainList2 rectList) {
    rects = rectList;
  }
  public tiMultiRectADomain2(tiRectDomain2 rd) {
    rects = new (tiDomains.region) tiRectDomainList2();
    if (!rd.isNull()) {
      rects.append(rd);
    }
  }
  public tiMultiRectADomain2(tiRectDomain2 [1d] rda) {
    // unchecked: assert that RectDomain's in rda are disjoint
    rects = new (tiDomains.region) tiRectDomainList2();
    foreach (p in rda.domain()) {
      rects.append(rda[p]);
    }
  }
  public tiMultiRectADomain2(Point<2> [1d] pa) {
    // unchecked: assert that Point's in pa are disjoint
    rects = new (tiDomains.region) tiRectDomainList2();
    foreach (p in pa.domain()) {
      tiRectDomain2 rd =
	new tiRectDomain2(pa[p],
				pa[p] + Point<2>.all(1),
				Point<2>.all(1));
      rects.append(rd);
    }
  }

  // Internal set relations routines
  private tiRectDomainList2 newSubtract(tiRectDomainList2 dl) {
    tiRectDomainList2 result = rects;

    for (tiRectDomainListIterator2 d_iter = dl.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      tiRectDomainList2 saved_result = result;
      result = new (tiDomains.region) tiRectDomainList2();
      for (tiRectDomainListIterator2 iter = saved_result.newIterator();
	   !iter.isEnd();
	   iter.advance()) {

	tiRectDomain2 id =
	  iter.dereference().multiply(d_iter.dereference());

	if (id.isNull()) {
	  result.append(iter.dereference());
	} else if (id.isEqual(iter.dereference())) {
	  // do nothing
	} else {
	  tiRectDomain2 rd = iter.dereference();
	  Point<2> p0 = rd.getLowerBound();
	  Point<2> p1 = rd.getUpperBound();
	  Point<2> stride = rd.getStride();

	  // slice
	  for (int i = 0; i < rd.getArity(); i++) {
	    int rd_p0 = p0.get(i);
	    int rd_p1 = p1.get(i);
	    int id_p0 = id.getLowerBound().get(i);
	    int id_p1 = id.getUpperBound().get(i);

	    if (rd_p0 < id_p0) {
	      result.append(new tiRectDomain2(p0,
						    p1.set(i, id_p0),
						    stride));
	      p0 = p0.set(i, id_p0);
	    }
	    if (rd_p1 > id_p1) {
	      result.append(new tiRectDomain2(p0.set(i,
							   (id_p1 -
							    1 +
							    stride.get(i))),
						    p1,
						    stride));
	      p1 = p1.set(i, id_p1);
	    }
	  }

	  // handle interior of overlap
	  for (int i = 0; i < rd.getArity(); i++) {
	    if (stride.get(i) < id.getStride().get(i)) {
	      for (int set_p0 = p0.get(i);
		   set_p0 < (p1.get(i) -
			     id.getStride().get(i));
		   set_p0 += id.getStride().get(i)) {
		result.
		  append(new tiRectDomain2(p0.set(i,
							(set_p0 +
							 stride.get(i))),
						 p1.set(i,
							(set_p0 +
							 id.
							 getStride().
							 get(i))),
						 stride));
	      }
	      stride = stride.set(i,
				  id.getStride().get(i));
	    }
	  }
	}
      }
    }

    return result;
  }

  // Set Relations
  public tiDomain2 add(tiDomain2 d) {
    tiRectDomainList2 mdl = d.getRectangles();
    tiRectDomainList2 result = newSubtract(mdl);

    for (tiRectDomainListIterator2 d_iter = mdl.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      result.append(d_iter.dereference());
    }

    return new (tiDomains.region) tiMultiRectADomain2(result);
  }
  public tiDomain2 difference(tiDomain2 d) {
    tiRectDomainList2 mdl = d.getRectangles();

    return new (tiDomains.region) tiMultiRectADomain2(newSubtract(mdl));
  }
  public tiDomain2 multiply(tiDomain2 d) {
    // this * d

    tiRectDomainList2 result = new (tiDomains.region) tiRectDomainList2();
    tiRectDomainList2 mdl = d.getRectangles();

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      for (tiRectDomainListIterator2 d_iter = mdl.newIterator();
	   !d_iter.isEnd();
	   d_iter.advance()) {

	tiRectDomain2 partial_result =
	  iter.dereference().multiply(d_iter.dereference());

	if (!partial_result.isNull()) {
	  result.append(partial_result);
	}
      }
    }

    return new (tiDomains.region) tiMultiRectADomain2(result);
  }
  public boolean isNull() {
    // this is null

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      if (!iter.dereference().isNull()) {
	return false;
      }
    }
    return true;
  }
  public boolean isNotNull() {
    return !isNull();
  }
  public boolean isEqual(tiDomain2 d) {
    // this == d
    return (isSubset(d) && d.isSubset(this));
  }
  public boolean isNotEqual(tiDomain2 d) {
    return (!isSubset(d) || !d.isSubset(this));
  }
  public boolean isSubset(tiDomain2 d) {
    // this <= d
    tiRectDomainList2 mdl = d.getRectangles();
    return newSubtract(mdl).isEmpty();
  }
  public boolean isStrictSubset(tiDomain2 d) {
    // this < d
    return isSubset(d) && (!d.isSubset(this));
  }
  public boolean isSuperset(tiDomain2 d) {
    return d.isSubset(this);
  }
  public boolean isStrictSuperset(tiDomain2 d) {
    return d.isStrictSubset(this);
  }

  // RectDomain Relations
  public tiDomain2 add(tiRectDomain2 rd) {
    return add(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public tiDomain2 difference(tiRectDomain2 rd) {
    return difference(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public tiDomain2 multiply(tiRectDomain2 rd) {
    return multiply(new (tiDomains.region) tiMultiRectADomain2(rd));
  }

  public boolean isEqual(tiRectDomain2 rd) {
    return isEqual(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public boolean isNotEqual(tiRectDomain2 rd) {
    return isNotEqual(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public boolean isSubset(tiRectDomain2 rd) {
    return isSubset(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public boolean isStrictSubset(tiRectDomain2 rd) {
    return isStrictSubset(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public boolean isSuperset(tiRectDomain2 rd) {
    return isSuperset(new (tiDomains.region) tiMultiRectADomain2(rd));
  }
  public boolean isStrictSuperset(tiRectDomain2 rd) {
    return isStrictSuperset(new (tiDomains.region) tiMultiRectADomain2(rd));
  }

  // Point Relations
  public tiDomain2 add(Point<2> p) {
    // this + p
    tiRectDomainList2 result = new (tiDomains.region) tiRectDomainList2();

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().add(p));
    }

    return new (tiDomains.region) tiMultiRectADomain2(result);
  }
  public tiDomain2 difference(Point<2> p) {
    // this - p
    tiRectDomainList2 result = new (tiDomains.region) tiRectDomainList2();

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().difference(p));
    }

    return new (tiDomains.region) tiMultiRectADomain2(result);
  }
  public tiDomain2 divide(Point<2> p) {
    // this / p
    tiDomain2 result = new (tiDomains.region) tiMultiRectADomain2();

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      // Call the add function to remove any overlaps generated by rounding
      // effects during the divide.
      result = result.add(iter.dereference().divide(p));
    }

    return result;
  }
  public tiDomain2 multiply(Point<2> p) {
    // this * p
    tiRectDomainList2 result = new (tiDomains.region) tiRectDomainList2();

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().multiply(p));
    }

    return new (tiDomains.region) tiMultiRectADomain2(result);
  }

  public tiDomain2 permute(Point<2> p) {
    tiRectDomainList2 result = new (tiDomains.region) tiRectDomainList2();

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result.append(iter.dereference().permute(p));
    }

    return new (tiDomains.region) tiMultiRectADomain2(result);
  }

  // Shape Information
  public boolean doesContain(Point<2> p) {
    // this contains p

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      if (iter.dereference().doesContain(p)) {
	return true;
      }
    }
    return false;
  }
  public boolean isRectangular() {
    joinRectangles();

    return rects.hasSingularity();
  }
  public int getNumPoints() {
    int result = 0;

    for (tiRectDomainListIterator2 iter = rects.newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      result = result + iter.dereference().getNumPoints();
    }

    return result;
  }
  public Point<2> getLowerBound() {
    Point<2> result;
    tiRectDomainListIterator2 iter = rects.newIterator();

    if (iter.isEnd()) {
      return Point<2>.all(0);
    } else {
      result = iter.dereference().getLowerBound();
      for (iter.advance();
	   !iter.isEnd();
	   iter.advance()) {
	result = result.getLowerBound(iter.dereference().getLowerBound());
      }
      return result;
    }
  }
  public Point<2> getUpperBound() {
    Point<2> result;
    tiRectDomainListIterator2 iter = rects.newIterator();

    if (iter.isEnd()) {
      return Point<2>.all(0);
    } else {
      result = iter.dereference().getUpperBound();
      for (iter.advance();
	   !iter.isEnd();
	   iter.advance()) {
	result = result.getUpperBound(iter.dereference().getUpperBound());
      }
      return result;
    }
  }
  public Point<2> getUpperMaxPoint() {
    return getUpperBound().sub(Point<2>.all(1));
  }
  public tiRectDomain2 getBoundingBox() {
    return new tiRectDomain2(getLowerBound(),
				   getUpperBound(),
				   Point<2>.all(1));
  }
  public tiRectDomainList2 getRectangles() {
    return rects;
  }
  public tiRectDomain2 [1d] getRectDomains() {
    int numRectangles = rects.getNumItems();
    tiRectDomain2 [1d] result =
      new tiRectDomain2 [[1 : numRectangles : 1]];
    int numRectsAdded = 0;

    for (tiRectDomainListIterator2 iter_x = rects.newIterator();
         !iter_x.isEnd();
         iter_x.advance()) {
      numRectsAdded++;
      result[[numRectsAdded]] = iter_x.dereference();
    }
    // assert (numRectsAdded == numRectangles);
    return result;
  }
  public Point<2> [1d] getPoints() {
    int numPoints = getNumPoints();
    Point<2> [1d] result =
      new Point<2> [[1 : numPoints : 1]];
    int numPointsAdded = 0;

    for (tiRectDomainListIterator2 iter_x = rects.newIterator();
         !iter_x.isEnd();
         iter_x.advance()) {
      RectDomain<2> rd = [iter_x.dereference().getLowerBound() :
                                iter_x.dereference().getUpperMaxPoint() :
                                iter_x.dereference().getLoopingStride()];
      foreach (p in rd) {
	numPointsAdded++;
	result[[numPointsAdded]] = p;
      }
    }
    // assert (numPointsAdded == numPoints);
    return result;
  }

  // Internal dynamic optimization routines
  private void joinRectangles() {
    boolean changes_made;
    tiRectDomainList2 currList = rects;

    do {
      changes_made = false;
      tiRectDomainList2 newList = new (tiDomains.region) tiRectDomainList2();
      boolean ignore[] = new (tiDomains.region) boolean[currList.getNumItems()];

      for (int i = 0; i < currList.getNumItems(); i++) {
	ignore[i] = false;
      }

      int searchIndexInit = 0;
      for (tiRectDomainListIterator2 iter_x = currList.newIterator();
	   !iter_x.isEnd();
	   iter_x.advance()) {
	if (!ignore[searchIndexInit]) {
	  int searchIndex = searchIndexInit + 1;
	  boolean matchFound = false;
	  for (tiRectDomainListIterator2 iter_comp_x =
		 currList.newIterator(iter_x).advance();
	       ((!iter_comp_x.isEnd()) && (!matchFound));
	       iter_comp_x.advance()) {
	    if (!ignore[searchIndex]) {
	      tiDomain2 result =
		iter_x.dereference().add(iter_comp_x.dereference());
	      tiRectDomainList2 rdl = result.getRectangles();
	      if (rdl.hasSingularity()) {
		tiRectDomain2 rd = rdl.getSingularity();

		newList.append(rd);
		changes_made = true;
		matchFound = true;
		ignore[searchIndex] = true;
	      }
	    }
	    searchIndex++;
	  }
	  if (!matchFound) {
	    newList.append(iter_x.dereference());
	  }
	}
	searchIndexInit++;
      }
      currList = newList;
    } while (changes_made);
    rects = currList;
  }

  // Dynamic optimizations
  public tiDomain2 demote() {
    joinRectangles();

    return this;
  }

  // Convert to a string
  public String toString() {
    String result;
    boolean isFirst;

    isFirst = true;
    result = "";
    for (tiRectDomainListIterator2 d_iter = rects.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      if (!isFirst) {
	result = result + " + ";
      }
      result = result + d_iter.dereference().toString();
      isFirst = false;
    }

    return result;
  }

  // Debugging
  /*
  public void print(String desc) {
    int count = 0;
    for (tiRectDomainListIterator2 d_iter = rects.newIterator();
	 !d_iter.isEnd();
	 d_iter.advance()) {
      count++;
      tiRectDomain2 rd = d_iter.dereference();
      Point<2> p = rd.getLowerBound();
      System.out.print(desc);
      System.out.print("(");
      System.out.print(count);
      System.out.print(") [[");
      for (int i = 0; i < p.arity(); i++) {
	if (i != 0) System.out.print(",");
	System.out.print(p.get(i));
      }
      System.out.print("] : ");
      Point<2> p2 = rd.getUpperBound();
      System.out.print("[");
      for (int i = 0; i < p2.arity(); i++) {
	if (i != 0) System.out.print(",");
	System.out.print(p2.get(i));
      }
      System.out.print("] : ");
      Point<2> p3 = rd.getStride();
      System.out.print("[");
      for (int i = 0; i < p3.arity(); i++) {
	if (i != 0) System.out.print(",");
	System.out.print(p3.get(i));
      }
      System.out.println("]]");
    }
  }
  */

  // State
  private tiRectDomainList2 rects;

}
